﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using System.Runtime.InteropServices;

namespace WpfUI
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        public MainWindow()
        {
            InitializeComponent();
        }

        private void Button_Click(object sender, RoutedEventArgs e)
        {
            AsmProxy asmP = new AsmProxy();
            double a, b, r;
            a = Double.Parse(txtA.Text);           //convert argument 1 from text (WPF UI) to double
            b = Double.Parse(txtB.Text);           //convert argument 2 from text (WPF UI) to double
            r = asmP.executeAsmAddTwoDoubles(a, b);//execute assembler code
            Result.Text = r.ToString();            //return value to the WPF UI as text
        }
    }

    public unsafe class AsmProxy
    {
        [DllImport("Asm.dll")]
        private static extern double asmAddTwoDoubles(double a, double b);

        public double executeAsmAddTwoDoubles(double a, double b)
        {
            return asmAddTwoDoubles(a, b);
        }
    }
}
